=== debian/changelog ===
eureka (2.0.2-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Update standards version to 4.6.1, no changes needed.

  [ Fabian Greffrath ]
  * Follow upstream take over of the project to github
  * Update debian/watch file
  * New upstream version 2.0.2
  * Update debian/copyright
  * Update Build-Depends on libgl-dev, add cmake, fluid and libxpm-dev
  * Build without unit tests, update file locations
  * Build without -Werror, do not duplicate CXXFLAGS
  * Add Forwarded status to patches
  * Bump Standards-Version to 4.6.2

 -- Fabian Greffrath <fabian@debian.org>  Wed, 24 Jul 2024 08:48:53 +0200
