=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_UNIT_TESTS=OFF

override_dh_auto_install:
	dh_auto_install -- \
		DESTDIR=$(CURDIR)/debian/eureka \
		PREFIX=/usr

override_dh_installchangelogs:
	dh_installchangelogs changelogs/$(DEB_VERSION_UPSTREAM).md

override_dh_installdocs:
	dh_installdocs AUTHORS.md README.txt

override_dh_installman:
	dh_installman misc/eureka.6
