=== debian/watch ===
version=4
https://github.com/ioan-chera/eureka-editor/tags \
https://github.com/ioan-chera/eureka-editor/archive/refs/tags/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
