## eureka 2.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
-cmake_minimum_required(VERSION 3.13)
+cmake_minimum_required(VERSION 3.28)
 
 set(CMAKE_OSX_DEPLOYMENT_TARGET "10.13" CACHE STRING "Minimum OS X deployment version")
 
-project(eureka-editor VERSION 2.0.2)
+project(eureka-editor VERSION 2.1.0)
 
 # Why not use the latest C++
 set(CMAKE_CXX_STANDARD 17)
@@ -139,6 +139,9 @@
 endif()
 
 add_subdirectory(src)
+if(UNIX AND NOT APPLE)  # Linux
+    target_include_directories(eurekasrc PRIVATE /usr/include/cairo)
+endif()
 if(APPLE)
     target_link_libraries(eurekasrc PRIVATE eurekamac)
     target_link_libraries(eurekamac PRIVATE eurekasrc)
