=== osx/CMakeLists.txt ===
add_subdirectory(EurekaApp)
