=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,28 @@
 message(STATUS "Enable testing: ${ENABLE_UNIT_TESTS}")
 
-# Following https://github.com/google/googletest/blob/main/googletest/README.md
-include(FetchContent)
-FetchContent_Declare(
-    googletest
-    GIT_REPOSITORY https://github.com/google/googletest.git
-    GIT_TAG v1.14.0
-)
-# For Windows: Prevent overriding the parent project's compiler/linker settings
-set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
-FetchContent_MakeAvailable(googletest)
-
+option(USE_SYSTEM_GOOGLE_TEST "Use system Google Test instead of locally-fetched source.")
+if(USE_SYSTEM_GOOGLE_TEST)
+    message(STATUS "Using system Google Test.")
+    find_package(GTest REQUIRED)
+    message(VERBOSE "Found GTEST_INCLUDE_DIRS ${GTEST_INCLUDE_DIRS}")
+    message(VERBOSE "Found GTEST_LIBRARIES ${GTEST_LIBRARIES}")
+    message(VERBOSE "Found GTEST_MAIN_LIBRARIES ${GTEST_MAIN_LIBRARIES}")
+    message(VERBOSE "Found GTEST_BOTH_LIBRARIES ${GTEST_BOTH_LIBRARIES}")
+    add_library(gtest_main ALIAS GTest::gtest_main)
+else()
+    message(STATUS "Using fetch-content Google Test for portability.")
+    # Following https://github.com/google/googletest/blob/main/googletest/README.md
+    include(FetchContent)
+    FetchContent_Declare(
+        googletest
+        GIT_REPOSITORY https://github.com/google/googletest.git
+        GIT_TAG v1.14.0
+        EXCLUDE_FROM_ALL
+    )
+    # For Windows: Prevent overriding the parent project's compiler/linker settings
+    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
+    FetchContent_MakeAvailable(googletest)
+endif()
 
 set(src ${CMAKE_SOURCE_DIR}/src)
 get_target_property(src_includes eurekasrc INCLUDE_DIRECTORIES)
@@ -50,6 +62,7 @@
 add_executable(
     test_general
     DocumentTest.cpp
+    e_basis_test.cpp
     e_checks_test.cpp
     e_commands_test.cpp
     e_cutpaste_test.cpp
@@ -62,8 +75,10 @@
     lib_tga_test.cpp
     lib_util_test.cpp
     m_bitvec_test.cpp
+    m_events_test.cpp
     m_files_test.cpp
     m_game_test.cpp
+    m_keys_test.cpp
     m_parse_test.cpp
     m_select_test.cpp
     m_streams_test.cpp
