=== debian/changelog ===
eureka (2.1.0-2) unstable; urgency=medium

  * Add two post-release patches from upstream:
    + Fixed failure to run on aarch64 systems
    + Fixed fatal error happening when loading DEHACKED lumps with
      unnamed thing entries (Closes: #1118948)

 -- Fabian Greffrath <fabian@debian.org>  Wed, 29 Oct 2025 21:21:25 +0100

eureka (2.1.0-1) unstable; urgency=medium

  * Update debian/watch file to version 5
  * New upstream version 2.1.0
  * Build-Depend on libfltk1.4-dev (Closes: #1102742)
  * Remove patches applied upstream
  * Fix reproducubility by defining BUILD_YEAR and BUILD_DATE, refresh
    patch
  * Enforce USE_SYSTEM_FLTK=ON
  * Bump Standards-Version to 4.7.2
  * Remove redundant RRR: no
  * Update Debian packaging copyright
  * Add Build-Depends on libjpeg-dev
  * Run wrap-and-sort

 -- Fabian Greffrath <fabian@debian.org>  Fri, 17 Oct 2025 09:32:02 +0200
