=== debian/control ===
Source: eureka
Section: utils
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Fabian Greffrath <fabian@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 fluid,
 libfltk1.4-dev,
 libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 libjpeg-dev,
 libxpm-dev,
 zlib1g-dev | libz-dev
Standards-Version: 4.7.2
Homepage: https://github.com/ioan-chera/eureka-editor
Vcs-Browser: https://salsa.debian.org/games-team/eureka
Vcs-Git: https://salsa.debian.org/games-team/eureka.git

Package: eureka
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 freedoom | game-data-packager
Description: map editor for the classic DOOM games
 Eureka is a cross-platform map editor for the classic DOOM games.
 It started as a fork of the Yadex editor attempting to make it use the
 FLTK GUI toolkit and implement multiple Undo / Redo.
 .
 Supported games include DOOM, DOOM 2, Final Doom, FreeDoom, HacX and Heretic.
 Supported source ports are Boom, EDGE, Doom Legacy and Odamex.
