=== debian/watch ===
Version: 5
Template: GitHub
Owner: ioan-chera
Project: eureka-editor
